/*
*/

#ifndef DEVICE_H
#define DEVICE_H

#include "common.h"


class Device
{
public:
    NTSTATUS PnpAdd();
    NTSTATUS PnpStart();
    void PnpStop();

public: // Static
    static NTSTATUS DispatchPnpAdd(KSDEVICE *ksDeviceObject);
    static NTSTATUS DispatchPnpStart(KSDEVICE *ksDeviceObject, IRP *irp,
                                     CM_RESOURCE_LIST *translatedResourceList,
                                     CM_RESOURCE_LIST *untranslatedResourceList);
    static void DispatchPnpStop(KSDEVICE *ksDeviceObject, IRP *irp);
    static void DispatchPnpRemove(KSDEVICE *ksDeviceObject, IRP *irp);
    static void DispatchSetPower(KSDEVICE *ksDeviceObject, IRP *irp,
                                 DEVICE_POWER_STATE to, DEVICE_POWER_STATE from);

private:
    Device(KSDEVICE *ksDeviceObject);
    ~Device();

    //NTSTATUS QueryInterface();

private: // Static
    static void Cleanup(Device *device);

private:
    KSDEVICE *m_ksDeviceObject;
};

#endif // DEVICE_H

